; CSP Terrain Builder Revision 0.1 by Cyberskunk Pictures written by Dieter Marfurt (C)2001/2002
; ---------------------


; ______________________________________________________________________ ini bbgui
Include "BBGui_include.bb" ; include the BBGui include file
AppTitle "CSP Terrain Builder Revision 0.1"
Graphics3D 640,480,16,2
SetBuffer BackBuffer()

Global font=LoadFont("Verdana",12,0,0)
Global guidesignvar.guidesign=guidesigndefault(0) ; our guidesign, the design the gui is in

; ---------------------------- ini csp-gui
Dim gad.gadget( 17 ) ; A dim to hold our gadgets

win.window=window( 254 , 0 , 386 , 91 , guidesignvar , font , 1 , "CSP Terrain Builder" , 1 , 1 , 0 , 3 , 1 )


gad(0)=gadgethscroller( win , 5 , 39 , 100 , 14 , "Smoothing Level" , 0 , guidesignvar , font ,16,0.5 )
gad(1)=gadgethscroller( win , 5 , 7 , 100 , 14 , "Pen Size" , 0 , guidesignvar , font ,16,0.3 )
gad(2)=gadgethscroller( win , 5 , 23 , 100 , 14 , "Pen Smoothness" , 0 , guidesignvar , font ,16,0.0 )
gad(3)=gadgethscroller( win , 5 , 55 , 100 , 14 , "Coolness" , 0 , guidesignvar , font ,16,1.0 )
gad(4)=gadgetbutton( win , 107 , 7 , 70 , 14 , "Load" , 0 , guidesignvar , font  )
gad(5)=gadgetbutton( win , 107 , 23 , 70 , 14 , "Save" , 0 , guidesignvar , font  )
gad(6)=gadgetbutton( win , 107 , 39 , 70 , 14 , "Rotate 90" , 0 , guidesignvar , font  )
gad(7)=gadgetbutton( win , 107 , 55 , 70 , 14 , "Smooth all" , 0 , guidesignvar , font  )
gad(8)=gadgetbutton( win , 179 , 7 , 70 , 14 , "Multiply all" , 0 , guidesignvar , font  )
gad(9)=gadgetbutton( win , 179 , 23 , 70 , 14 , "Divide all" , 0 , guidesignvar , font  )
gad(10)=gadgetbutton( win , 269 , 7 , 14 , 14 , "Z" , 0 , guidesignvar , font  )
gad(11)=gadgetbutton( win , 277 , 23 , 14 , 14 , "X" , 0 , guidesignvar , font  )
gad(12)=gadgetbutton( win , 261 , 23 , 14 , 14 , "X" , 0 , guidesignvar , font  )
gad(13)=gadgetbutton( win , 270 , 39 , 14 , 14 , "Z" , 0 , guidesignvar , font  )
gad(14)=gadgetbutton( win , 302 , 23 , 14 , 14 , "Y" , 0 , guidesignvar , font  )
gad(15)=gadgetbutton( win , 302 , 7 , 14 , 14 , "Y" , 0 , guidesignvar , font  )
gad(16)=gadgetbutton( win , 326 , 7 , 14 , 14 , "A" , 0 , guidesignvar , font  )
gad(17)=gadgetbutton( win , 326 , 23 , 14 , 14 , "A" , 0 , guidesignvar , font  )

; .................................................eo ini bbgui

maxgads=17
Dim aus$(maxgads)


camera=CreateCamera()
CameraFogMode camera,1
CameraFogRange camera,0.0,400.0
CameraFogColor camera,0,0,0
cax#=65
cay#=30
caz#=-45
PositionEntity camera,cax#,cay#,caz#

light=CreateLight()
RotateEntity light,0,0,45
PositionEntity light,40,300,45


Dim feld#(140,140)
Dim feld2#(140,140)

; Create Terrain
Global terrain=CreateTerrain(128)

; Texture terrain etc
grass=CreateTexture(256,256,9)

SetBuffer TextureBuffer(grass)
Color 20,50,0
Rect 0,0,256,256,1
For i=0 To 10000
Color Rnd(80,90),Rnd(140,180),Rnd(20,30)
 Plot Rnd(0,256),Rnd(0,256)
Next
Color 255,255,255
Line 0,0,255,0
Line 0,1,255,1

Line 0,0,0,255
Line 1,0,1,255
Line 2,0,2,255
Line 2,0,2,255
SetBuffer BackBuffer()
EntityTexture terrain,grass
ScaleEntity terrain,1,50,1
TerrainShading terrain,1

; make 3D-Cursor
cur=CreateSphere(7)
ScaleEntity cur,1.0,1.0,1.0
EntityColor cur,255,0,0
EntityAlpha cur,0.3
EntityOrder cur,-1

cur2=CreateSphere(7)
ScaleEntity cur2,1.0,1.0,1.0
EntityAlpha cur2,0.7

; initial fader settings
weich#=100.0 ; factor smoothing all
weich2#=0.0 ; factor pen smoothness
stift=3 ; pen size
;rund=0

; _______________________________________MAIN
While Not KeyDown( 1 )
; keys
If KeyDown( 205 )=True Or msg$=">" Then ; turn ri
 cax#=cax#+1.0
EndIf
If KeyDown( 203 )=True Or msg$="<" Then ;turn le
 cax#=cax#-1.0
EndIf
If KeyDown( 208 )=True Or msg$="b" Then  ; backw
 caz#=caz#-1.0
EndIf
If KeyDown( 200 )=True Or msg$="f" Then  ; forw
 caz#=caz#+1.0
EndIf
If KeyDown(78)=True Or msg$="h" ;  height cam+
 cay#=cay#-1
EndIf
If KeyDown(74)=True Or msg$="l" ; height cam -
 cay#=cay#+1
EndIf
PositionEntity camera,cax#,cay#+1,caz#
;.......................................................FX
If KeyDown(68)=True Or msg$="0" ;F10 save

	file$=windowfilerequest$(GraphicsWidth()/2-200,GraphicsHeight()/2-150,400,300,guidesignvar,font,"Please choose a CSP Terrain File to save..",".trn")
	If file$<>"" 
;	 If FileType(file$)	     ; allow overwriting without prompting
     If Len(file$)>4
      If Right$(file$,4)=".trn"
       dateiname$=Left$(file$,Len(file$)-4)

;....................
 si=WriteFile(dateiname$+".trn") ; write terrain-data
 For j=0 To 128
  For i=0 To 128
   WriteFloat si,feld#(i,j)
  Next
 Next
 CloseFile(si)
 si=WriteFile(dateiname$+".bbi") ; write bb-code

 WriteLine si,"; ************* CSP Terrain-Builder Paste-Code **************"
 WriteLine si,";"
 WriteLine si,";this Code might be copied into your Program to load a"
 WriteLine si,";Terrain built by the CSP Terrain Builder"
 WriteLine si,";"
 WriteLine si,";the following remarked Lines are not required to load the "
 WriteLine si,";csp Terrain, but they can be used if desired"
 WriteLine si,";"
 WriteLine si,";Graphics3D 640,480,16,2"
 WriteLine si,";SetBuffer BackBuffer()"
 WriteLine si,";camera=CreateCamera()"
 WriteLine si,";CameraFogMode camera,1"
 WriteLine si,";CameraFogRange camera,0.0,400.0"
 WriteLine si,";CameraFogColor camera,0,0,0"
 WriteLine si,";cax#=65"
 WriteLine si,";cay#=30"
 WriteLine si,";caz#=-45"
 WriteLine si,";PositionEntity camera,cax#,cay#,caz#"
 WriteLine si,";light=CreateLight()"
 WriteLine si,";RotateEntity light,0,0,45"
 WriteLine si,";PositionEntity light,40,300,45"
 WriteLine si,";"
 WriteLine si,"; the next Code IS required to load the Terrain."
 WriteLine si,";"
 WriteLine si,""

 WriteLine si,";______________LOAD CSP TERRAIN_________________"
 WriteLine si,"csp_terrain=CreateTerrain(128)"

 WriteLine si,"ScaleEntity csp_terrain,1,50,1
 WriteLine si,"TerrainShading csp_terrain,1
 WriteLine si,""

 WriteLine si,"; ... create a Texture on the fly if needed"
 WriteLine si,";csp_ttex=CreateTexture(256,256,9)"
 WriteLine si,";EntityTexture csp_terrain,csp_ttex"
 WriteLine si,";SetBuffer TextureBuffer(csp_ttex)"
 WriteLine si,";Color 50,50,50"
 WriteLine si,";Rect 0,0,255,255"
 WriteLine si,";Color 0,255,0"
 WriteLine si,";Rect 0,0,50,255"
 WriteLine si,";Rect 0,0,255,50"
 WriteLine si,";SetBuffer BackBuffer()"

 WriteLine si,""
 WriteLine si,"Dim csp_tfield#(130,130)"
 WriteLine si,"si=ReadFile("+Chr$(34)+dateiname$+".trn"+Chr$(34)+")"
 WriteLine si,"For j=0 To 128"
 WriteLine si," For i=0 To 128"
 WriteLine si,"  csp_tfield#(i,j)=ReadFloat(si)"
 WriteLine si,"  ModifyTerrain csp_terrain,(i),(j),csp_tfield#(i,j)"
 WriteLine si," Next"
 WriteLine si,"Next"
 WriteLine si,"CloseFile(si)"
 WriteLine si,""

 WriteLine si,";UpdateWorld()"
 WriteLine si,";RenderWorld()"
 WriteLine si,";Flip"
 WriteLine si,";While KeyHit(1)=0"
 WriteLine si,";VWait"
 WriteLine si,";Wend"
 WriteLine si,";End"

 CloseFile(si)

   EndIf
  EndIf
 EndIf


EndIf

If KeyDown(88)=True Or msg$="2" ;F12 load

;----bbgui fselect
	file$=windowfilerequest$(GraphicsWidth()/2-200,GraphicsHeight()/2-150,400,300,guidesignvar,font,"Please select a CSP Terrain File to load..",".trn")
	If file$<>"" ; only if "ok" has been pressed in file requester 
		If FileType(file$)	     ;only if file exists
;----eo bbgui fselect
 If Len(file$)>4
  If Right$(file$,4)=".trn"
   si=ReadFile(file$) 
    For j=0 To 128
     For i=0 To 128
      feld#(i,j)=ReadFloat(si)
      ModifyTerrain terrain,(i),(j),feld#(i,j)
     Next
    Next
    CloseFile(si)
   EndIf
  EndIf
     EndIf
     EndIf
EndIf

;If KeyDown(59)=True Or msg$="1" ;F1 toggle 
; rund = rund Xor 1
;Delay 500
;EndIf

If KeyDown(55)=True Or msg$="a" ;* cam look down
 TurnEntity camera,2.0,0,0
EndIf

If KeyDown(181)=True Or msg$="A" ;/ cam look up
 TurnEntity camera,-2.0,0,0
EndIf

If KeyDown(19)=True Or msg$="r" ;R Rotate 90
 For i=0 To 128 
  For j=0 To 128
   feld2#(i,j)=feld#(128-j,i)
  Next
 Next
 For i=0 To 128 
  For j=0 To 128
   feld#(i,j)=feld2#(i,j)
  Next
 Next
 For i=0 To 128 
  For j=0 To 128
   ModifyTerrain terrain,(i),(j),feld#(i,j)
  Next
 Next
Delay 500
EndIf

If KeyDown(30)=True Or msg$="m" ;A amplify
For i=0 To 128 
 For j=0 To 128
  feld#(i,j)=feld#(i,j)*1.1
  If feld#(i,j)>1.0 Then feld#(i,j)=1.0
  ModifyTerrain terrain,(i),(j),feld#(i,j)
 Next
Next
EndIf

If KeyDown(32)=True Or msg$="d" ;D divide
For i=0 To 128 
 For j=0 To 128
  feld#(i,j)=feld#(i,j)*0.9
  If feld#(i,j)<0.0 Then feld#(i,j)=0.0
  ModifyTerrain terrain,(i),(j),feld#(i,j)
 Next
Next
EndIf

If KeyDown(31)=True Or msg$="s" ;S smooth
If smtogg=0
 For j=0 To 128
  For i=0 To 128
  w#=0
  wold#=feld#(i,j)
   For j2=0 To 2
    For i2=0 To 2
     w#=w#+feld#(i+i2,j+j2)
    Next
   Next
   w#=((wold#*weich#)+w#)/(weich#+9)
   ModifyTerrain terrain,(i),(j),w#
   feld#(i,j)=w#
  Next
 Next
 smtogg=1
Else
 For j=128 To 2 Step -1
  For i=128 To 2 Step -1
  w#=0
  wold#=feld#(i,j)
   For j2=2 To 0 Step -1
    For i2=2 To 0 Step -1
     w#=w#+feld#(i-i2,j-j2)
    Next
   Next
   w#=((wold#*weich#)+w#)/(weich#+9)
   ModifyTerrain terrain,(i),(j),w#
   feld#(i,j)=w#
  Next
 Next
 smtogg=0
EndIf
EndIf


; ......position cursor-sphere and check gui
msg$="" ; (holder for the gui action)
mx=MouseX()
my=MouseY()
; check if on gui
wx1=windowx(win)
wy1=windowy(win)
wx2=windowwidth(win)+wx1
wy2=windowheight(win)+wy1

;/////////////////////////////////////////////////////////////////////  CHECK GUI
info=0
If mx>wx1 And mx<wx2 And my>wy1 And my<wy2 ; mouse on gui
 If MouseDown(1)=True
  guigui=1
 EndIf
 For i=0 To 3
   aus$(i)= gadgetgetvalue$( gad(i))
 Next
 For i=4 To maxgads
   aus$(i)= Str$(gadgetpressed( gad(i)))
 Next
If MouseDown(1)=True
wert1#=aus$(0); smoothing level
wert2#=aus$(1); pen size
wert3#=aus$(2); pen smoothness
wert4#=aus$(3); not used yet
wert1#=1.0-wert1#
weich#=wert1# * 200.0 ; factor smooth
weich2#=wert3# * 100.0 ; factor rundstift
stift=Int(Floor(wert2#*10))

If aus$(4)="1" Then msg$="2"
If aus$(5)="1" Then msg$="0"
If aus$(6)="1" Then msg$="r"
If aus$(7)="1" Then msg$="s"
If aus$(8)="1" Then msg$="m"
If aus$(9)="1" Then msg$="d"
If aus$(10)="1" Then msg$="f"
If aus$(11)="1" Then msg$=">"
If aus$(12)="1" Then msg$="<"
If aus$(13)="1" Then msg$="b"
If aus$(14)="1" Then msg$="h"
If aus$(15)="1" Then msg$="l"
If aus$(16)="1" Then msg$="a"
If aus$(17)="1" Then msg$="A"
EndIf

Else ; mouse on drawing area
If guigui=1
 While MouseDown(1)=True ; if any gui action right before then don't draw
  RenderWorld
  windowinteractall()
  gadgetinteractall()
  windowdrawall()
  Flip
 Wend
 guigui=0
EndIf
mx2#=mx
my2#=my
tx#=Int(Floor((mx2#*127.0)/640.0))
tz#=Int(Floor(128.0-((my2#*127.0)/480.0)))
If tx#<0.0 Then tx#=0.0
If tz#<0.0 Then tz#=0.0
PositionEntity cur,tx#,feld#(tx#,tz#)*50,tz#
PositionEntity cur2,tx#,feld#(tx#,tz#)*50,tz#

;........Draw
If  MouseDown(1)=True ; draw positive
 For j=0 To stift
  For i=0 To stift
   txwo#=tx#+i
   tzwo#=tz#+j
   If txwo#>=1.0 And txwo#<=127.0 And tzwo#>=1.0 And tzwo#<=127.0
    fe#=feld#(txwo#,tzwo#)+0.1
    If fe#> 1.0 Then fe#=1.0
    If fe#< 0.0 Then fe#=0.0
    feld#(txwo#,tzwo#)=fe#
    ModifyTerrain terrain,(txwo#),(tzwo#),fe#
   EndIf
  Next
 Next
 If weich2#>0.01 ; have to smooth around the region?
 
 For j=-2 To stift+2
  For i=-2 To stift+2
   txwo#=tx#+i
   tzwo#=tz#+j
   If txwo#>=1.0 And txwo#<=127.0 And tzwo#>=1.0 And tzwo#<=127.0

  w#=0
  wold#=feld#(txwo#,tzwo#)
   For j2=0 To 2
    For i2=0 To 2
     w#=w#+feld#(txwo#+i2,tzwo#+j2)
    Next
   Next
   w#=((wold#*weich2#)+w#)/(weich2#+9)
   ModifyTerrain terrain,(txwo#),(tzwo#),w#
   feld#(txwo#,tzwo#)=w#

   EndIf
  Next
 Next
 EndIf
EndIf

If  MouseDown(2)=True ; draw negative
 For j=0 To stift
  For i=0 To stift
   txwo#=tx#+i
   tzwo#=tz#+j
   If txwo#>=1.0 And txwo#<=127.0 And tzwo#>=1.0 And tzwo#<=127.0
    fe#=feld#(txwo#,tzwo#)-0.1
    If fe#> 1.0 Then fe#=1.0
    If fe#< 0.0 Then fe#=0.0
    feld#(txwo#,tzwo#)=fe#
    ModifyTerrain terrain,(txwo#),(tzwo#),fe#
   EndIf
  Next
 Next
 If weich2#>0.01 ; have to smooth around the region?
 
 For j=-2 To stift+2
  For i=-2 To stift+2
   txwo#=tx#+i
   tzwo#=tz#+j
   If txwo#>=1.0 And txwo#<=127.0 And tzwo#>=1.0 And tzwo#<=127.0

  w#=0
  wold#=feld#(txwo#,tzwo#)
   For j2=0 To 2
    For i2=0 To 2
     w#=w#+feld#(txwo#+i2,tzwo#+j2)
    Next
   Next
   w#=((wold#*weich2#)+w#)/(weich2#+9)
   ModifyTerrain terrain,(txwo#),(tzwo#),w#
   feld#(txwo#,tzwo#)=w#

   EndIf
  Next
 Next
 EndIf
EndIf

EndIf ; endif mouse not on gui

UpdateWorld
RenderWorld


windowinteractall()
gadgetinteractall()
windowdrawall()

If info=1
Text 0,0,"Cam: Cursorkeys,+,-,/,* "
Text 0,20,"a=multiply, d=divide, s=smooth, r=rotate Terrain"
Text 0,40,"Draw: LMB,RMB"
Text 0,60,"F10=save, F12=load"
Text 0,80,""
Text 0,120,Str$(tx#)
Text 0,140,Str$(tz#)
Text 0,160,Str$(cax#)
Text 0,180,Str$(caz#)

For i=0 To 3
 Text 0,240+(i*12),Str$(i)+" "+aus$(i)
Next

EndIf
Flip

Wend

End